/*
 * File         : Srv_Handler.h
 * Author       : Tomasz Stachowiak
 * Created      : Tue May 19 19:28:21 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __SRV_HANDLER_H
#define __SRV_HANDLER_H

#include <BVN/BVN.h>
#include <BVN/Event_Handler.h>
#include <BVN/Reactor.h>

template <class PEER_STREAM>
class Svc_Handler : public Event_Handler
{
 public:

  virtual int open(Reactor *reactor);
  PEER_STREAM *peer(void);
  virtual void close(void);
  virtual HANDLE get_handle(void);
  virtual int handle_event(Event_Type et);

 private:

  PEER_STREAM peer_stream_;
};

template <class PEER_STREAM>
int Svc_Handler<PEER_STREAM>::open(Reactor *reactor)
{
  return reactor->register_handler(this, READ_EVENT);
}

template <class PEER_STREAM>
PEER_STREAM *Svc_Handler<PEER_STREAM>::peer(void)
{
  return &this->peer_stream_;
}

template <class PEER_STREAM>
HANDLE Svc_Handler<PEER_STREAM>::get_handle(void)
{
  return this->peer_stream_.get_handle();
}

template <class PEER_STREAM>
void Svc_Handler<PEER_STREAM>::close(void)
{
}

template <class PEER_STREAM>
int Svc_Handler<PEER_STREAM>::handle_event(Event_Type et)
{
  return 0;
}


#endif

